package ui

import (
	"os"

	"git.bullercodeworks.com/brian/wandle"
)

const (
	BrowseId = iota << 5
	AboutId
)

type Ui struct {
	config Config
	wandle *wandle.Program

	browseScreen *browseScreen
}

func NewUi() *Ui {
	u := new(Ui)
	u.browseScreen = NewBrowseScreen(u)
	u.config = Config{
		sep: string(os.PathSeparator),
	}
	u.wandle = wandle.NewProgram(u.browseScreen)
	return u
}

func (u *Ui) Start() error { return u.wandle.Start() }
